#line 1 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
#line 28 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
typedef struct i2c_
{
 volatile  unsigned short int  address;
 volatile  unsigned short int  dummy;
 volatile  unsigned short int  data_received;
 volatile  unsigned short int  bytes_received;
 volatile  unsigned short int  data_sent;
 volatile  unsigned short int  bytes_sent;
 volatile  unsigned short int  *ptr;
  unsigned short int  send_buffer[ 11 ];
  unsigned short int  receive_buffer[ 8 ];
} i2c_struct;
#line 77 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
volatile  unsigned short int  white;
volatile  unsigned short int  off;
volatile  unsigned short int  brightness;
volatile  unsigned short int  color;
volatile  unsigned short int  update;
volatile i2c_struct i2c_data;
 unsigned int  red;
 unsigned int  green;
 unsigned int  blue;

 unsigned int  brightness_levels[ 32 ] =
{
 0,
 11,
 12,
 14,
 16,
 19,
 22,
 25,
 29,
 34,
 40,
 47,
 55,
 64,
 74,
 87,
 101,
 118,
 138,
 161,
 187,
 219,
 255,
 298,
 347,
 405,
 473,
 552,
 644,
 751,
 877,
 1023
};


 unsigned short int  colors[ 24 ][3] =
{
 {255, 0, 0},
 {223, 32, 0},
 {191, 64, 0},
 {159, 96, 0},
 {128, 128, 0},
 {96, 159, 0},
 {64, 191, 0},
 {32, 223, 0},
 {0, 255, 0},
 {0, 223, 32},
 {0, 191, 64},
 {0, 159, 96},
 {0, 128, 128},
 {0, 96, 159},
 {0, 64, 191},
 {0, 32, 223},
 {0, 0, 255},
 {32, 0, 223},
 {64, 0, 191},
 {96, 0, 159},
 {128, 0, 128},
 {159, 0, 96},
 {191, 0, 64},
 {223, 0, 32}
};
#line 156 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
interrupt()
{
  unsigned short int  tmp;
#line 162 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
 if(INTCON.IOCIF)
 {
 tmp = PORTB;


 if(IOCBF& 0b00010000  && tmp& 0b00100000  && !off)
 {
 if(brightness< 32 -1)
 ++brightness;
 update = 1;
 }


 if(IOCBF& 0b00100000  && tmp& 0b00010000  && !off)
 {
 if(brightness>0)
 --brightness;
 update = 1;
 }


 if(IOCBF& 0b00001000  && brightness)
 {
 if(off)
 off = 0;
 else
 off = 1;
 update = 1;
 }


 if(IOCBF& 0b00000010  && tmp& 0b00000100  && !white && !off && brightness)
 {
 ++color;
 if(color== 24 )
 color = 0;
 update = 1;
 }


 if(IOCBF& 0b00000100  && tmp& 0b00000010  && !white && !off && brightness)
 {
 --color;
 if(color> 24 -1)
 color =  24 -1;
 update = 1;
 }


 if(IOCBF& 0b00000001  && !off && brightness)
 {
 if(white)
 white = 0;
 else
 white = 1;
 update = 1;
 }

 IOCBF = 0;
 return;
 }
#line 226 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
 if(PIR1.SSPIF)
 {

 if(SSPSTAT.R_NOT_W)
 {

 if(SSPCON2.ACKSTAT)
 {
 i2c_data.data_sent = 1;
 }

 else
 {

 if(!SSPSTAT.D_NOT_A)
 {
 i2c_data.address = SSPBUF & 0b11111110;
 i2c_data.ptr = &i2c_data.send_buffer[0];
 i2c_data.bytes_sent = 0;
 }

 if(i2c_data.bytes_sent< 11 )
 {
 SSPBUF = *i2c_data.ptr;
 ++i2c_data.bytes_sent;
 ++i2c_data.ptr;
 }
 else
 {
 SSPBUF = 0x00;
 }
 }
 }

 else
 {

 if(SSPSTAT.P)
 {
 i2c_data.data_received = 1;
 SSPCON3.PCIE = 0;
 }

 else
 {

 if(!SSPSTAT.D_NOT_A)
 {
 i2c_data.address = SSPBUF & 0b11111110;
 i2c_data.ptr = &i2c_data.receive_buffer[0];
 i2c_data.bytes_received = 0;
 SSPCON3.PCIE = 1;
 }

 else
 {
 if(i2c_data.bytes_received< 8 )
 {
 *i2c_data.ptr = SSPBUF;
 ++i2c_data.bytes_received;
 ++i2c_data.ptr;
 }
 }
 }
 }
 SSPCON1.CKP = 1;
 PIR1.SSPIF = 0;
 return;
 }
}
#line 300 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
void i2c_slave_init()
{

 i2c_data.address = 0;
 i2c_data.dummy = 0;
 i2c_data.data_received = 0;
 i2c_data.bytes_received = 0;
 i2c_data.data_sent = 0;
 i2c_data.ptr = &i2c_data.send_buffer[0];
 for(i2c_data.bytes_sent=0; i2c_data.bytes_sent< 11 ; ++i2c_data.bytes_sent)
 {
 i2c_data.send_buffer[i2c_data.bytes_sent] = i2c_data.bytes_sent;
 }
 i2c_data.send_buffer[0] = 88;
 i2c_data.bytes_sent = 0;
 for(i2c_data.bytes_received=0; i2c_data.bytes_received< 8 ; ++i2c_data.bytes_received)
 {
 i2c_data.receive_buffer[i2c_data.bytes_received] = 0;
 }
 i2c_data.bytes_received = 0;

 TRISC.B3 = 1;
 TRISC.B4 = 1;

 SSPADD =  0b11100000 ;

 SSPMSK =  0b11111111 ;


 SSPSTAT.SMP = 1;

 SSPSTAT.CKE = 1;
 SSPSTAT.BF = 0;

 SSPCON1.WCOL = 0;
 SSPCON1.SSPOV = 0;
 SSPCON1.SSPEN = 0;
 SSPCON1.CKP = 1;
 SSPCON1.SSPM3 = 1;
 SSPCON1.SSPM2 = 1;
 SSPCON1.SSPM1 = 1;
 SSPCON1.SSPM0 = 0;

 SSPCON2.GCEN = 0;
 SSPCON2.SEN = 1;

 SSPCON3.PCIE = 0;
 SSPCON3.SCIE = 0;
 SSPCON3.BOEN = 0;
 SSPCON3.SDAHT = 1;
 SSPCON3.SBCDE = 0;
 SSPCON3.AHEN = 0;
 SSPCON3.DHEN = 0;

 PIR1.SSPIF = 0;
 PIE1.SSPIE = 1;
 PIR2.BCLIF = 0;
 PIE2.BCLIE = 0;
 INTCON.PEIE = 1;
 INTCON.GIE = 1;

 SSPCON1.SSPEN = 1;
}
#line 370 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
static void init()
{


 TRISA = 0b11101111;
 PORTA = 0b00010000;

 TRISB = 0b11111111;
 PORTB = 0b00000000;

 TRISC = 0b10111101;
 PORTC = 0b01000010;

 ANSELA = 0b00000100;
 ANSELB = 0b00000000;

 APFCON = 0b00000000;



 OSCCON = 0b11110000;


 white = 1;
 off = 0;
 brightness = 1;
 color = 0;
 update = 1;


 IOCBP =  0b00001000  |  0b00000001 ;
 IOCBN =  0b00010000  |  0b00100000  |  0b00000010  |  0b00000100 ;
 INTCON &= (~ 0b00000001 );
 IOCBF = 0;
 INTCON |=  0b00001000 ;
 INTCON |=  0b10000000 ;


 TMR2 = 0x00;
 PR2 = 0xFF;
 TMR4 = 85;
 PR4 = 0xFF;
 TMR6 = 170;
 PR6 = 0xFF;
 T2CON = 0b00011100;
 T4CON = 0b00011100;
 T6CON = 0b00011100;


 CCPTMRS0 = 0b00010000;
 CCPTMRS1 = 0b00000010;
 CCP2CON = 0b00001111;
 CCP3CON = 0b00001111;
 CCP5CON = 0b00001100;


 i2c_slave_init();
}
#line 433 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
static void PWM_red( unsigned int  dutycycle)
{

 dutycycle &= 0b1111111111;

 dutycycle = 1023 - dutycycle;

 CCPR5L = dutycycle>>2;

 CCP5CON = 0b00001100 | ((dutycycle & 0b11)<<4);
}
#line 449 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
static void PWM_green( unsigned int  dutycycle)
{

 dutycycle &= 0b1111111111;

 CCPR2L = dutycycle>>2;

 CCP2CON = (CCP2CON & 0b11001111) | ((dutycycle & 0b11)<<4);
}
#line 463 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
static void PWM_blue( unsigned int  dutycycle)
{

 dutycycle &= 0b1111111111;

 CCPR3L = dutycycle>>2;

 CCP3CON = (CCP3CON & 0b11001111) | ((dutycycle & 0b11)<<4);
}

static void set_rgb()
{
  unsigned long int  tmp;
 update = 0;

 if(off)
 {
 red = 0;
 green = 0;
 blue = 0;
 }
 else
 {
 if(white)
 {
 tmp = (( unsigned long int ) brightness_levels[brightness] *  255 ) >> 8;
 red = ( unsigned int ) tmp;
 tmp = (( unsigned long int ) brightness_levels[brightness] *  90 ) >> 8;
 green = ( unsigned int ) tmp;
 tmp = (( unsigned long int ) brightness_levels[brightness] *  50 ) >> 8;
 blue = ( unsigned int ) tmp;
 }
 else
 {
 tmp = (( unsigned long int ) brightness_levels[brightness] * colors[color][0]) >> 8;
 red = ( unsigned int ) tmp;
 tmp = (( unsigned long int ) brightness_levels[brightness] * colors[color][1]) >> 8;
 green = ( unsigned int ) tmp;
 tmp = (( unsigned long int ) brightness_levels[brightness] * colors[color][2]) >> 8;
 blue = ( unsigned int ) tmp;
 }
 }
 PWM_red(red);
 PWM_green(green);
 PWM_blue(blue);
 update = 0;
}
#line 514 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
static void fill_send_buffer()
{
 i2c_data.send_buffer[0] = 0;
 i2c_data.send_buffer[1] = white;
 i2c_data.send_buffer[2] = off;
 i2c_data.send_buffer[3] = brightness;
 i2c_data.send_buffer[4] = color;
 i2c_data.send_buffer[5] = red>>7;
 i2c_data.send_buffer[6] = red & 0b01111111;
 i2c_data.send_buffer[7] = green>>7;
 i2c_data.send_buffer[8] = green & 0b01111111;
 i2c_data.send_buffer[9] = blue>>7;
 i2c_data.send_buffer[10] = blue & 0b01111111;
}
#line 532 "Z:/My Documents/EmbeddedSystems/mikroC/DimmerRGB/DimmerRGB.c"
void main()
{

 init();


 while(1)
 {
 if(update)
 {
 set_rgb();
 fill_send_buffer();
 }
 }
}
